



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux常用基本命令：三剑客命令之-awk模式用法(2)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux常用基本命令：三剑客命令之-awk模式用法(2)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 05:38:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1，正则模式，在/etc/passwd中 过滤出使用/bin/bash的用户</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ awk -v FS=":" 'BEGIN{printf "%-10s%-10s%-10s\n", "用户 名", "用户id","bash"} /\/bin\/bash$/{printf "%-10s\t%-10s\t%-10s\n", $1,$3,$NF}' /etc/passwd<br />
用户名       用户id      bash<br />
root                       /bin/bash<br />
ghostwu                 /bin/bash<br />
guest-iilhaz               /bin/bash<br />
ghostwu@dev:~/linux/awk$ grep "/bin/bash" /etc/passwd<br />
root:x:::root:/root:/bin/bash<br />
ghostwu:x:::ghostwu,,,:/home/ghostwu:/bin/bash<br />
guest-iilhaz:x:::Guest:/tmp/guest-iilhaz:/bin/bash</pre>
</div>
<p>&gt;从/etc/passwd中取出\bin\bash结尾的行</p>
<p>&gt;找出符合条件的行之后，用":"号分隔，将该行文本分段</p>
<p>&gt;取出需要的段，格式化输出</p>
<p>&gt;用BEGIN模式和printf格式化文本</p>
<p>2，提取/etc/passwd中，7位以上的字母账号，使用{n,m}次数匹配的正则，需要加上--re-interval</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ awk --re-interval -v FS=":" 'BEGIN{printf "%-10s%-10s\n","用户名","id"} /^\w{7,}/{printf "%-10s\t%-10s\n", $1,$3}' /etc/passwd<br />
用户名       id<br />
systemd-timesync<br />
systemd-network<br />
systemd-resolve<br />
systemd-bus-proxy<br />
messagebus<br />
lightdm<br />
whoopsie<br />
dnsmasq<br />
kernoops<br />
ghostwu          </pre>
</div>
<p>3，行范围匹配模式</p>
<p>格式：awk '/正则1/,/正则2/{动作}'&nbsp; FILE</p>
<p>匹配ghostwu第一次出现的行，到zhanzhao第一次出现的行 之间的所有行，【注意：是以第一次出现为匹配标准】</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ cat -n ghostwu.txt<br />
         ghostwu  man<br />
         zhangsan<br />
         lisi<br />
         ghostwu  man<br />
         zhanzhao  man<br />
         peter  man<br />
         zhanzhao  man<br />
ghostwu@dev:~/linux/awk$ awk '/ghostwu/,/zhanzhao/ {print}' ghostwu.txt<br />
ghostwu  man<br />
zhangsan<br />
lisi<br />
ghostwu  man<br />
zhanzhao  man</pre>
</div>
<p>当然，上面的例子，也可以用之前的内置变量NR，关系表达式模式实现更简单</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ awk 'NR&gt;=1 &amp;&amp; NR&lt;=5{print}' ghostwu.txt<br />
ghostwu  man<br />
zhangsan<br />
lisi<br />
ghostwu  man<br />
zhanzhao  man</pre>
</div>
<p>4，关系运算符和正则搭配使用，匹配满足格式的网段</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ cat host.txt<br />
name    ip地址<br />
host1    192.168.1.1<br />
host2    192.177.81.1<br />
host3    10.0.0.5<br />
host4    192.168.3.98<br />
host5    192.168.3.98<br />
host6    192.168.9.254<br />
ghostwu@dev:~/linux/awk$ awk --re-interval '$2~/192\.168\.[0-9]{1,3}\.[0-9]{1,3}/{print}' host.txt<br />
host1    192.168.1.1<br />
host4    192.168.3.98<br />
host5    192.168.3.98<br />
host6    192.168.9.254</pre>
</div>
<p>$2：表示第2列， 他后面的~ 表示第二列与后面的正则表达式匹配结果为真，就执行action，这里就是打印当前行{print}，如果加上! 就是取反</p>
<div>
<pre class="prettyprint linenums">ghostwu@dev:~/linux/awk$ awk --re-interval '$2!~/192\.168\.[0-9]{1,3}\.[0-9]{1,3}/{print}' host.txt<br />
name    ip地址<br />
host2    192.177.81.1<br />
host3    10.0.0.5</pre>
</div>
<table>
<tbody>
<tr>
<td>
<p>关系运算符</p>
</td>
<td>
<p>含义</p>
</td>
<td>
<p>用法示例</p>
</td>
</tr>
<tr>
<td>
<p>&lt;</p>
</td>
<td>
<p>小于</p>
</td>
<td>
<p>x &lt; y</p>
</td>
</tr>
<tr>
<td>
<p>&lt;=</p>
</td>
<td>
<p>小于等于</p>
</td>
<td>
<p>x &lt;= y</p>
</td>
</tr>
<tr>
<td>
<p>==</p>
</td>
<td>
<p>等于</p>
</td>
<td>
<p>x == y</p>
</td>
</tr>
<tr>
<td>
<p>!=</p>
</td>
<td>
<p>不等于</p>
</td>
<td>
<p>x != y</p>
</td>
</tr>
<tr>
<td>
<p>&gt;=</p>
</td>
<td>
<p>大于等于</p>
</td>
<td>
<p>x &gt;= y</p>
</td>
</tr>
<tr>
<td>
<p>&gt;</p>
</td>
<td>
<p>大于</p>
</td>
<td>
<p>x &gt; y</p>
</td>
</tr>
<tr>
<td>
<p>~</p>
</td>
<td>
<p>与对应的正则匹配则为真</p>
</td>
<td>
<p>x ~ /正则/</p>
</td>
</tr>
<tr>
<td>
<p>!~</p>
</td>
<td>
<p>与对应的正则不匹配则为真</p>
</td>
<td>
<p>x !~ /正则/</p>
</td>
</tr>
</tbody>
</table>
<p><strong>模式小结：</strong></p>
<p>&gt;空模式</p>
<p>&gt;关系运算模式</p>
<p>&gt;正则模式</p>
<p>&gt;行范围模式</p>
<p>&gt;BEGIN/END模式</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvk6l8.html">tomcat&colon;域名指向项目名</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq47dmjq.html">maven 搜索不到想从本地仓库依赖的jar包--重建本地maven仓库索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gx4e0q.html">T-SQL性能调整（一）--编译和重新编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwdp19.html">Kmeans方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okyx6l9.html">&lbrack;Security&rsqb; Automatically adding CSRF tokens to ajax calls when using jQuery--转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v254q.html">Crontab使用mailx的一点发现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7yj1q.html">懒加载 lazy load</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv44v1q.html">POJ 1300 欧拉通路&amp;amp&semi;欧拉回路</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z745e9.html">WeakSelf和StrongSelf</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd32vz9.html">Java Final and Immutable</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4og39.html">HDU2289-Cup-二分</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zv1x09.html">对cordova插件配置文件plugin&period;xml的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk3lld8.html">&period;Net Remoting 调用远程对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/95047yz8.html">第一讲 新手如何学习HTTP协议之实践项目多开微信机器人</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v0wz9.html">C&num; 树状图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnexxq.html">python中深拷贝和浅拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvprxq.html">input type &equals; file 上传图片转为base64</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd617v9.html">mongo官方企业版安装及数据库授权使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vemmq.html">JAVA记录-JSP内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmew6g9.html">【python-opencv】16-图像平滑</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25y1moq.html">java&lowbar;io</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25y1pvq.html">程序的流程控制-分支结构  if</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4e3g8.html">Vuejs&mdash;&mdash;（3）计算属性，样式和类绑定</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1do609.html">Trinity的分步运行</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdz7gv9.html">通过shell快速配置J2EE运行环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjrloz9.html">学习react</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1lxkeq.html">&lbrack;视频&rsqb;K8飞刀 hacking team flash0day shellcode exploit</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rov6q.html">js按钮  防重复提交</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpzg1q.html">课程四&lpar;Convolutional Neural Networks&rpar;，第四 周（Special applications&colon; Face recognition &amp;amp&semi; Neural style transfer） &mdash;&mdash; 2&period;Programming assignments：Art generation with Neural Style Transfer</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjd0r39.html">xlwt set style making error&colon; More than 4094 XFs &lpar;styles&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
